﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SqlServer.Dts.Runtime;

namespace InsertTask
{
    class Program
    {
        static void Main(string[] args)
        {
            const string SourcePackagePath = @"c:\book\chapter19\SourcePackage.dtsx";
            const string DestinationPackagePath = @"c:\book\chapter19\DestinationPackage.dtsx";

            PackageEvents events = new PackageEvents();
            Application app = new Application();

            // Load the source package
            Package source = app.LoadPackage(SourcePackagePath, events);
            
            // Load the destination package
            Package destination = app.LoadPackage(DestinationPackagePath, events);

            // Get a reference to the task we want to copy, and remove it from the original package.
            // The source package won't be modified if we don't save it.
            Executable task = source.Executables["Execute SQL Task"];
            source.Executables.Remove(task);

            // get a reference to the connection manager we want to copy
            ConnectionManager cm = source.Connections["SourceConnection"];
            source.Connections.Remove(cm);

            // add both objects to the destination package
            destination.Connections.Join(cm);
            destination.Executables.Join(task);

            // save the destination package to preserve the changes
            app.SaveToXml(DestinationPackagePath, destination, events);
        }
    }
}
